import{s as Re,f as g,n as Be,o as Ue}from"../chunks/scheduler.37c15a92.js";import{S as Ne,i as Oe,g as i,s as n,r as c,m as nt,H as re,A as We,h as p,f as s,c as l,j as it,u,x as r,n as lt,B as ge,k as m,y as h,a,v as f,d as v,t as d,w as x}from"../chunks/index.7cb9c9b8.js";import{H as _,E as Ye}from"../chunks/EditOnGithub.858acfec.js";function De(oe){let o,rt,pt,gt,y,ot,M,ce="To better understand Q-Learning, let’s take a simple example:",ct,b,ue,ut,T,he="<li>You’re a mouse in this tiny maze. You always <strong>start at the same starting point.</strong></li> <li>The goal is <strong>to eat the big pile of cheese at the bottom right-hand corner</strong> and avoid the poison. After all, who doesn’t like cheese?</li> <li>The episode ends if we eat the poison, <strong>eat the big pile of cheese</strong>, or if we take more than five steps.</li> <li>The learning rate is 0.1</li> <li>The discount rate (gamma) is 0.99</li>",ht,S,fe,ft,C,ve="The reward function goes like this:",vt,z,de="<li><strong>+0:</strong> Going to a state with no cheese in it.</li> <li><strong>+1:</strong> Going to a state with a small cheese in it.</li> <li><strong>+10:</strong> Going to the state with the big pile of cheese.</li> <li><strong>-10:</strong> Going to the state with the poison and thus dying.</li> <li><strong>+0</strong> If we take more than five steps.</li>",dt,I,xe,xt,E,we="To train our agent to have an optimal policy (so a policy that goes right, right, down), <strong>we will use the Q-Learning algorithm</strong>.",wt,L,$t,P,$e,_t,G,_e="So, for now, <strong>our Q-table is useless</strong>; we need <strong>to train our Q-function using the Q-Learning algorithm.</strong>",yt,H,ye="Let’s do it for 2 training timesteps:",Mt,k,Me="Training timestep 1:",bt,Q,Tt,A,be="Because epsilon is big (= 1.0), I take a random action. In this case, I go right.",St,q,Te,Ct,j,zt,w,ne,It,Ae='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>=</mo><mn>1</mn></mrow><annotation encoding="application/x-tex">R_{t+1} = 1</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.6444em;"></span><span class="mord">1</span></span></span></span>',Et,Lt,R,Se,Pt,B,Gt,$,le,Ht,qe='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>Q</mi><mo stretchy="false">(</mo><msub><mi>S</mi><mi>t</mi></msub><mo separator="true">,</mo><msub><mi>A</mi><mi>t</mi></msub><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">Q(S_t, A_t)</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">Q</span><span class="mopen">(</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.05764em;">S</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:-0.0576em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord"><span class="mord mathnormal">A</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.2806em;"><span style="top:-2.55em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathnormal mtight">t</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span>',kt,Qt,U,Ce,At,N,ze,qt,O,Ie="Training timestep 2:",jt,W,Rt,Y,Ee="<strong>I take a random action again, since epsilon=0.99 is big</strong>. (Notice we decay epsilon a little bit because, as the training progress, we want less and less exploration).",Bt,D,Le="I took the action ‘down’. <strong>This is not a good action since it leads me to the poison.</strong>",Ut,F,Pe,Nt,J,Ot,K,ie,V,pe,Wt,je='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>R</mi><mrow><mi>t</mi><mo>+</mo><mn>1</mn></mrow></msub><mo>=</mo><mo>−</mo><mn>10</mn></mrow><annotation encoding="application/x-tex">R_{t+1} = -10</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8917em;vertical-align:-0.2083em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.00773em;">R</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3011em;"><span style="top:-2.55em;margin-left:-0.0077em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight">t</span><span class="mbin mtight">+</span><span class="mord mtight">1</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.2083em;"><span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:0.7278em;vertical-align:-0.0833em;"></span><span class="mord">−</span><span class="mord">10</span></span></span></span>',Yt,Dt,X,Ge,Ft,Z,Jt,tt,He,Kt,et,ke="Because we’re dead, we start a new episode. But what we see here is that, <strong>with two explorations steps, my agent became smarter.</strong>",Vt,st,Qe="As we continue exploring and exploiting the environment and updating Q-values using the TD target, the <strong>Q-table will give us a better and better approximation. At the end of the training, we’ll get an estimate of the optimal Q-function.</strong>",Xt,at,Zt,mt,te;return y=new _({props:{title:"A Q-Learning example",local:"q-learning-example",headingTag:"h1"}}),L=new _({props:{title:"Step 1: Initialize the Q-table",local:"step1",headingTag:"h2"}}),Q=new _({props:{title:"Step 2: Choose an action using the Epsilon Greedy Strategy",local:"step2",headingTag:"h2"}}),j=new _({props:{title:"Step 3: Perform action At, get Rt+1 and St+1",local:"step3",headingTag:"h2"}}),B=new _({props:{title:"Step 4: Update Q(St, At)",local:"step4",headingTag:"h2"}}),W=new _({props:{title:"Step 2: Choose an action using the Epsilon Greedy Strategy",local:"step2-2",headingTag:"h2"}}),J=new _({props:{title:"Step 3: Perform action At, get Rt+1 and St+1",local:"step3-3",headingTag:"h2"}}),Z=new _({props:{title:"Step 4: Update Q(St, At)",local:"step4-4",headingTag:"h2"}}),at=new Ye({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit2/q-learning-example.mdx"}}),{c(){o=i("meta"),rt=n(),pt=i("p"),gt=n(),c(y.$$.fragment),ot=n(),M=i("p"),M.textContent=ce,ct=n(),b=i("img"),ut=n(),T=i("ul"),T.innerHTML=he,ht=n(),S=i("img"),ft=n(),C=i("p"),C.textContent=ve,vt=n(),z=i("ul"),z.innerHTML=de,dt=n(),I=i("img"),xt=n(),E=i("p"),E.innerHTML=we,wt=n(),c(L.$$.fragment),$t=n(),P=i("img"),_t=n(),G=i("p"),G.innerHTML=_e,yt=n(),H=i("p"),H.textContent=ye,Mt=n(),k=i("p"),k.textContent=Me,bt=n(),c(Q.$$.fragment),Tt=n(),A=i("p"),A.textContent=be,St=n(),q=i("img"),Ct=n(),c(j.$$.fragment),zt=n(),w=i("p"),ne=nt("By going right, I get a small cheese, so"),It=new re(!1),Et=nt(" and I’m in a new state."),Lt=n(),R=i("img"),Pt=n(),c(B.$$.fragment),Gt=n(),$=i("p"),le=nt("We can now update"),Ht=new re(!1),kt=nt(" using our formula."),Qt=n(),U=i("img"),At=n(),N=i("img"),qt=n(),O=i("p"),O.textContent=Ie,jt=n(),c(W.$$.fragment),Rt=n(),Y=i("p"),Y.innerHTML=Ee,Bt=n(),D=i("p"),D.innerHTML=Le,Ut=n(),F=i("img"),Nt=n(),c(J.$$.fragment),Ot=n(),K=i("p"),ie=nt("Because I ate poison, "),V=i("strong"),pe=nt("I get"),Wt=new re(!1),Yt=nt(", and I die."),Dt=n(),X=i("img"),Ft=n(),c(Z.$$.fragment),Jt=n(),tt=i("img"),Kt=n(),et=i("p"),et.innerHTML=ke,Vt=n(),st=i("p"),st.innerHTML=Qe,Xt=n(),c(at.$$.fragment),Zt=n(),mt=i("p"),this.h()},l(t){const e=We("svelte-u9bgzb",document.head);o=p(e,"META",{name:!0,content:!0}),e.forEach(s),rt=l(t),pt=p(t,"P",{}),it(pt).forEach(s),gt=l(t),u(y.$$.fragment,t),ot=l(t),M=p(t,"P",{"data-svelte-h":!0}),r(M)!=="svelte-9fmuny"&&(M.textContent=ce),ct=l(t),b=p(t,"IMG",{src:!0,alt:!0}),ut=l(t),T=p(t,"UL",{"data-svelte-h":!0}),r(T)!=="svelte-n6lz09"&&(T.innerHTML=he),ht=l(t),S=p(t,"IMG",{src:!0,alt:!0}),ft=l(t),C=p(t,"P",{"data-svelte-h":!0}),r(C)!=="svelte-dok1jh"&&(C.textContent=ve),vt=l(t),z=p(t,"UL",{"data-svelte-h":!0}),r(z)!=="svelte-93cdg2"&&(z.innerHTML=de),dt=l(t),I=p(t,"IMG",{src:!0,alt:!0}),xt=l(t),E=p(t,"P",{"data-svelte-h":!0}),r(E)!=="svelte-pbs6nn"&&(E.innerHTML=we),wt=l(t),u(L.$$.fragment,t),$t=l(t),P=p(t,"IMG",{src:!0,alt:!0}),_t=l(t),G=p(t,"P",{"data-svelte-h":!0}),r(G)!=="svelte-9m32nr"&&(G.innerHTML=_e),yt=l(t),H=p(t,"P",{"data-svelte-h":!0}),r(H)!=="svelte-29jh6q"&&(H.textContent=ye),Mt=l(t),k=p(t,"P",{"data-svelte-h":!0}),r(k)!=="svelte-51ll5c"&&(k.textContent=Me),bt=l(t),u(Q.$$.fragment,t),Tt=l(t),A=p(t,"P",{"data-svelte-h":!0}),r(A)!=="svelte-1hg390z"&&(A.textContent=be),St=l(t),q=p(t,"IMG",{src:!0,alt:!0}),Ct=l(t),u(j.$$.fragment,t),zt=l(t),w=p(t,"P",{});var ee=it(w);ne=lt(ee,"By going right, I get a small cheese, so"),It=ge(ee,!1),Et=lt(ee," and I’m in a new state."),ee.forEach(s),Lt=l(t),R=p(t,"IMG",{src:!0,alt:!0}),Pt=l(t),u(B.$$.fragment,t),Gt=l(t),$=p(t,"P",{});var se=it($);le=lt(se,"We can now update"),Ht=ge(se,!1),kt=lt(se," using our formula."),se.forEach(s),Qt=l(t),U=p(t,"IMG",{src:!0,alt:!0}),At=l(t),N=p(t,"IMG",{src:!0,alt:!0}),qt=l(t),O=p(t,"P",{"data-svelte-h":!0}),r(O)!=="svelte-120ic1h"&&(O.textContent=Ie),jt=l(t),u(W.$$.fragment,t),Rt=l(t),Y=p(t,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-14kapt5"&&(Y.innerHTML=Ee),Bt=l(t),D=p(t,"P",{"data-svelte-h":!0}),r(D)!=="svelte-7qp2oa"&&(D.innerHTML=Le),Ut=l(t),F=p(t,"IMG",{src:!0,alt:!0}),Nt=l(t),u(J.$$.fragment,t),Ot=l(t),K=p(t,"P",{});var me=it(K);ie=lt(me,"Because I ate poison, "),V=p(me,"STRONG",{});var ae=it(V);pe=lt(ae,"I get"),Wt=ge(ae,!1),Yt=lt(ae,", and I die."),ae.forEach(s),me.forEach(s),Dt=l(t),X=p(t,"IMG",{src:!0,alt:!0}),Ft=l(t),u(Z.$$.fragment,t),Jt=l(t),tt=p(t,"IMG",{src:!0,alt:!0}),Kt=l(t),et=p(t,"P",{"data-svelte-h":!0}),r(et)!=="svelte-1heq24d"&&(et.innerHTML=ke),Vt=l(t),st=p(t,"P",{"data-svelte-h":!0}),r(st)!=="svelte-1eluo1b"&&(st.innerHTML=Qe),Xt=l(t),u(at.$$.fragment,t),Zt=l(t),mt=p(t,"P",{}),it(mt).forEach(s),this.h()},h(){m(o,"name","hf:doc:metadata"),m(o,"content",Fe),g(b.src,ue="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Maze-Example-2.jpg")||m(b,"src",ue),m(b,"alt","Maze-Example"),g(S.src,fe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-1.jpg")||m(S,"src",fe),m(S,"alt","Maze-Example"),g(I.src,xe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-2.jpg")||m(I,"src",xe),m(I,"alt","Maze-Example"),g(P.src,$e="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Example-1.jpg")||m(P,"src",$e),m(P,"alt","Maze-Example"),g(q.src,Te="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-3.jpg")||m(q,"src",Te),m(q,"alt","Maze-Example"),It.a=Et,g(R.src,Se="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-4.jpg")||m(R,"src",Se),m(R,"alt","Maze-Example"),Ht.a=kt,g(U.src,Ce="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-5.jpg")||m(U,"src",Ce),m(U,"alt","Maze-Example"),g(N.src,ze="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/Example-4.jpg")||m(N,"src",ze),m(N,"alt","Maze-Example"),g(F.src,Pe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-6.jpg")||m(F,"src",Pe),m(F,"alt","Maze-Example"),Wt.a=Yt,g(X.src,Ge="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-7.jpg")||m(X,"src",Ge),m(X,"alt","Maze-Example"),g(tt.src,He="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit3/q-ex-8.jpg")||m(tt,"src",He),m(tt,"alt","Maze-Example")},m(t,e){h(document.head,o),a(t,rt,e),a(t,pt,e),a(t,gt,e),f(y,t,e),a(t,ot,e),a(t,M,e),a(t,ct,e),a(t,b,e),a(t,ut,e),a(t,T,e),a(t,ht,e),a(t,S,e),a(t,ft,e),a(t,C,e),a(t,vt,e),a(t,z,e),a(t,dt,e),a(t,I,e),a(t,xt,e),a(t,E,e),a(t,wt,e),f(L,t,e),a(t,$t,e),a(t,P,e),a(t,_t,e),a(t,G,e),a(t,yt,e),a(t,H,e),a(t,Mt,e),a(t,k,e),a(t,bt,e),f(Q,t,e),a(t,Tt,e),a(t,A,e),a(t,St,e),a(t,q,e),a(t,Ct,e),f(j,t,e),a(t,zt,e),a(t,w,e),h(w,ne),It.m(Ae,w),h(w,Et),a(t,Lt,e),a(t,R,e),a(t,Pt,e),f(B,t,e),a(t,Gt,e),a(t,$,e),h($,le),Ht.m(qe,$),h($,kt),a(t,Qt,e),a(t,U,e),a(t,At,e),a(t,N,e),a(t,qt,e),a(t,O,e),a(t,jt,e),f(W,t,e),a(t,Rt,e),a(t,Y,e),a(t,Bt,e),a(t,D,e),a(t,Ut,e),a(t,F,e),a(t,Nt,e),f(J,t,e),a(t,Ot,e),a(t,K,e),h(K,ie),h(K,V),h(V,pe),Wt.m(je,V),h(V,Yt),a(t,Dt,e),a(t,X,e),a(t,Ft,e),f(Z,t,e),a(t,Jt,e),a(t,tt,e),a(t,Kt,e),a(t,et,e),a(t,Vt,e),a(t,st,e),a(t,Xt,e),f(at,t,e),a(t,Zt,e),a(t,mt,e),te=!0},p:Be,i(t){te||(v(y.$$.fragment,t),v(L.$$.fragment,t),v(Q.$$.fragment,t),v(j.$$.fragment,t),v(B.$$.fragment,t),v(W.$$.fragment,t),v(J.$$.fragment,t),v(Z.$$.fragment,t),v(at.$$.fragment,t),te=!0)},o(t){d(y.$$.fragment,t),d(L.$$.fragment,t),d(Q.$$.fragment,t),d(j.$$.fragment,t),d(B.$$.fragment,t),d(W.$$.fragment,t),d(J.$$.fragment,t),d(Z.$$.fragment,t),d(at.$$.fragment,t),te=!1},d(t){t&&(s(rt),s(pt),s(gt),s(ot),s(M),s(ct),s(b),s(ut),s(T),s(ht),s(S),s(ft),s(C),s(vt),s(z),s(dt),s(I),s(xt),s(E),s(wt),s($t),s(P),s(_t),s(G),s(yt),s(H),s(Mt),s(k),s(bt),s(Tt),s(A),s(St),s(q),s(Ct),s(zt),s(w),s(Lt),s(R),s(Pt),s(Gt),s($),s(Qt),s(U),s(At),s(N),s(qt),s(O),s(jt),s(Rt),s(Y),s(Bt),s(D),s(Ut),s(F),s(Nt),s(Ot),s(K),s(Dt),s(X),s(Ft),s(Jt),s(tt),s(Kt),s(et),s(Vt),s(st),s(Xt),s(Zt),s(mt)),s(o),x(y,t),x(L,t),x(Q,t),x(j,t),x(B,t),x(W,t),x(J,t),x(Z,t),x(at,t)}}}const Fe='{"title":"A Q-Learning example","local":"q-learning-example","sections":[{"title":"Step 1: Initialize the Q-table","local":"step1","sections":[],"depth":2},{"title":"Step 2: Choose an action using the Epsilon Greedy Strategy","local":"step2","sections":[],"depth":2},{"title":"Step 3: Perform action At, get Rt+1 and St+1","local":"step3","sections":[],"depth":2},{"title":"Step 4: Update Q(St, At)","local":"step4","sections":[],"depth":2},{"title":"Step 2: Choose an action using the Epsilon Greedy Strategy","local":"step2-2","sections":[],"depth":2},{"title":"Step 3: Perform action At, get Rt+1 and St+1","local":"step3-3","sections":[],"depth":2},{"title":"Step 4: Update Q(St, At)","local":"step4-4","sections":[],"depth":2}],"depth":1}';function Je(oe){return Ue(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ze extends Ne{constructor(o){super(),Oe(this,o,Je,De,Re,{})}}export{Ze as component};
